#ifndef INCL_FILEINPUT_H
#define INCL_FILEINPUT_H

/*-----------------------------------------------------------------------
 * Xclasses header file
 * 
 * Copyright (C) 1998 Jrgen Schmitz
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 *-----------------------------------------------------------------------
 */

#include <Xclasses/types.h>
#include <Xclasses/group.h>
#include <Xclasses/file_dialog.h>

class fileinput : public group
{
	friend class pfileinput;
	
	class pfileinput *p;

public:
	file_dialog	fi_fdialog;

    fileinput(void);
    virtual ~fileinput();

	void GSetLimits(void);
    int Create(void);
    void Free(void);

	void SetFile(char *);
	void GetFile(char *,int size);

	void ModeCommand(void);
	void ModeLoadFile(void);
	void ModeSaveFile(void);
	void ModeDir(void);
};

#endif
