#ifndef INCL_GFXOBJECT_H
#define INCL_GFXOBJECT_H

/*-----------------------------------------------------------------------
 * Xclasses header file
 * 
 * Copyright (C) 1998 Jrgen Schmitz
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 *-----------------------------------------------------------------------
 */

#include <Xclasses/types.h>
#include <Xclasses/Xcolors.h>

#define ADJUST_LEFT		0
#define ADJUST_CENTER	1
#define ADJUST_RIGHT	2
        
#define ADJUST_TOP		0
#define ADJUST_MIDDLE	4
#define ADJUST_BOTTOM	8

#define NOLIMIT			-1

class gfx_object : public Xcolors
{
public:
	gfx_object(void);
	virtual ~gfx_object();

	virtual void Adjust(int);

	virtual void draw_normal(class gadget *g,int x,int y,int w,int h);
	virtual void draw_selected(class gadget *g,int x,int y,int w,int h);
	virtual void draw_locked(class gadget *g,int x,int y,int w,int h);
	virtual void draw_selectedlocked(class gadget *g,int x,int y,int w,int h);

	virtual int height(class gadget *g);	// NOLIMIT if scalable
	virtual int width(class gadget *g);		// NOLIMIT if scalable
};

// all do nothing and return NOLIMIT


#endif
