#ifndef INCL_GOSELBUTTON_H
#define INCL_GOSELBUTTON_H

/*-----------------------------------------------------------------------
 * Xclasses header file
 * 
 * Copyright (C) 1998 Jrgen Schmitz
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 *-----------------------------------------------------------------------
 */

#include <Xclasses/types.h>
#include <Xclasses/selgadget.h>
#include <Xclasses/Ddraw.h>
#include <Xclasses/Xcolors.h>
#include <Xclasses/gfx_object.h>

class go_selbutton : public selgadget, private Ddraw
{
	friend class pgo_selbutton;

	class pgo_selbutton *p;

public:
    virtual void GExpose(XEvent *event);
    virtual void GActionPress(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
    virtual void GActionRelease(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
	virtual void GSetLimits(void);
	virtual int GActivate(XEvent *event,int why);
	virtual int GSelected(XEvent *event,int why,int wasabove);
	
public:
    go_selbutton();
    virtual ~go_selbutton();

    int Create(void);
    void Object(gfx_object *);
    void Object(gfx_object &obj) { Object(&obj); }
    
    void UseLimit(void);
    void NoLimit(void);				// default
    void UseLocked(void);
    void NotUseLocked(void);		// default
    void UseBorder(void);			// default
    void NoBorder(void);
    void NoKeyBorder(void);
	void Aspect(int minx,int miny,int maxx,int maxy);
	void Symmetric(void);			// calls Aspect(1,1,1,1)

	virtual void State(int st);
	virtual int  State(void);
};

#endif
