#ifndef INCL_GRAPHIC_H
#define INCL_GRAPHIC_H

/*-----------------------------------------------------------------------
 * Xclasses header file
 * 
 * Copyright (C) 1998 Jrgen Schmitz
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 *-----------------------------------------------------------------------
 */

#include <time.h>
#include <Xclasses/types.h>
#include <Xclasses/gadget.h>
#include <Xclasses/Xcolors.h>
#include <Xclasses/Ddraw.h>


class graphic : public gadget, private Ddraw
{
	friend class pgraphic;
	
	class pgraphic *p;

public:
    virtual void GExpose(XEvent *event);
    virtual void GActionPress(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
    virtual void GActionRelease(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
    virtual int GActivate(XEvent *event,int why);
    virtual int GSelected(XEvent *event,int why,int wasabove);
    virtual void GSetLimits(void);

public:
	graphic();
    virtual ~graphic();

    virtual int Create(void);
    void Free(void);
	int CreatePixmap(void);		// normally called by Create()
	int CreatePixmap(int depth);

	void Size(int w,int h);
	Pixmap pixmap(void);
	GC gc(void);

	void Draw(void);

	int FontHeight(void);
	int FontAscent(void);
	void Clear(void);
	void Foreground(int);
	void Line(int,int,int,int);
	void DrawString(int x,int y,char *);
	int StringLength(char *);
	void FillRectangle(int x,int y,int w,int h);
	int Font(char *name);
};

#endif
