#ifndef INCL_IMAGE_H
#define INCL_IMAGE_H

/*-----------------------------------------------------------------------
 * Xclasses header file
 * 
 * Copyright (C) 1998 Jrgen Schmitz
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 *-----------------------------------------------------------------------
 */

#include <Xclasses/types.h>
#include <Xclasses/gadget.h>
#include <Xclasses/Xcolors.h>
#include <Xclasses/Ddraw.h>
#include <Xclasses/gfx_object.h>


class image : public gadget, private Ddraw
{
	friend class pimage;
	
	class pimage *p;

public:
    virtual void GExpose(XEvent *event);
    virtual void GSetLimits(void);

public:
	image();
    virtual ~image();

    virtual int Create(void);
    void Free(void);

	void Object(class gfx_object *);
	void Object(class gfx_object &g) { Object(&g); };
	
	void Border(void);		// default
	void NoBorder(void); 
};

#endif
